define([
    'jquery'
], function($){
    'use strict';

    $.widget('filoblu.videos_tracking',{
        _create:function(){
            if(typeof w.dataLayer !== 'undefined' && typeof w.plyrVideos !== 'undefined' && w.plyrVideos.length > 0){
                $.each(w.plyrVideos,function(index,thisPlayer){
                    if(thisPlayer.provider === "youtube" || thisPlayer.provider === "vimeo"){
                        thisPlayer.on('ready',function(){
                            var checkEmbed = setInterval(trackVideo,100);

                            function trackVideo(){
                                if(typeof thisPlayer.embed !== 'undefined'){
                                    clearInterval(checkEmbed);

                                    var push25 = true,
                                        push50 = true,
                                        push75 = true,
                                        eventsElement = thisPlayer.provider === "youtube" ? thisPlayer : thisPlayer.embed,
                                        videoUrlTemp = $('iframe',thisPlayer.elements.container)[0].src,
                                        videoUrl = videoUrlTemp.substring(0,videoUrlTemp.indexOf('?'));

                                    if(thisPlayer.config.autoplay){
                                        w.dataLayer.push({
                                            'event':'Custom Video',
                                            'eventVideoUrl':videoUrl,
                                            'eventAction':'Autoplay'
                                        });
                                    }

                                    eventsElement.on('play',function(){
                                        w.dataLayer.push({
                                            'event':'Custom Video',
                                            'eventVideoUrl':videoUrl,
                                            'eventAction':'Play'
                                        });
                                    });

                                    eventsElement.on('timeupdate',function(data){
                                        var duration = thisPlayer.embed.getDuration(),
                                            currentTime = thisPlayer.embed.getCurrentTime(),
                                            currentPercentage = Math.round(currentTime * 100 / duration);

                                        if(currentPercentage === 25){
                                            if(push25){
                                                w.dataLayer.push({
                                                    'event':'Custom Video',
                                                    'eventVideoUrl':videoUrl,
                                                    'eventAction':'25%'
                                                });

                                                push25 = false;
                                            }
                                        } else if(currentPercentage === 50){
                                            if(push50){
                                                w.dataLayer.push({
                                                    'event':'Custom Video',
                                                    'eventVideoUrl':videoUrl,
                                                    'eventAction':'50%'
                                                });

                                                push50 = false;
                                            }
                                        } else if(currentPercentage === 75){
                                            if(push75){
                                                w.dataLayer.push({
                                                    'event':'Custom Video',
                                                    'eventVideoUrl':videoUrl,
                                                    'eventAction':'75%'
                                                });

                                                push75 = false;
                                            }
                                        }
                                    });

                                    eventsElement.on('pause',function(){
                                        w.dataLayer.push({
                                            'event':'Custom Video',
                                            'eventVideoUrl':videoUrl,
                                            'eventAction':'Pause'
                                        });
                                    });

                                    eventsElement.on('ended',function(){
                                        w.dataLayer.push({
                                            'event':'Custom Video',
                                            'eventVideoUrl':videoUrl,
                                            'eventAction':'Ended'
                                        });
                                    });
                                }
                            }
                        });
                    }
                });
            }
        }
    });

    return $.filoblu.videos_tracking;
});
